--- uscan	2005-08-04 04:15:22.000000000 +0200
+++ uscan-neu	2005-09-09 23:24:41.000000000 +0200
@@ -43,7 +43,7 @@
 	}
     }
 }
-my $CURRENT_WATCHFILE_VERSION = 3;
+my $CURRENT_WATCHFILE_VERSION = 4;
 
 my $progname = basename($0);
 my $modified_conf_msg;
@@ -627,6 +627,9 @@
 		elsif ($opt =~ /^dversionmangle\s*=\s*(.+)/) {
 		    @{$options{'dversionmangle'}} = split /;/, $1;
 		}
+		elsif ($opt =~ /^localfilename\s*=\s*(.+)/) {
+		    @{$options{'localfilename'}} = split /;/, $1;
+		}
 		else {
 		    warn "$progname warning: unrecognised option $opt\n";
 		}
@@ -807,6 +810,13 @@
     }
 
     my $newfile_base=basename($newfile);
+    if (exists $options{'localfilename'})
+    {
+        $newfile_base=$newfile;
+    }
+    foreach my $pat (@{$options{'localfilename'}}) {
+	eval "\$newfile_base =~ $pat;";
+    }
     # Remove HTTP header trash
     if ($site =~ m%^http://%)
     {
@@ -921,6 +931,11 @@
     # Download newer package
     if ($upstream_url =~ m%^http://%) {
 	print STDERR "$progname debug: requesting URL $upstream_url\n" if $debug;
+
+	# substitute HTML entities
+	# TODO: anything else than "&amp;" required?
+	$upstream_url =~ s/&amp;/&/;
+
 	$request = HTTP::Request->new('GET', $upstream_url);
 	$response = $user_agent->request($request, "../$newfile_base");
 	if (! $response->is_success) {
